Foreman - Feature #12873

Update Rails to 4.1.latest
12/18/2015 06:06 AM - Dominic Cleal

Status: Closed
Priority: Normal
Assignee: Dominic Cleal
Category: Rails
Target version: 1.11.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: 1325632 Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/3082
Description

#7230 updates Rails to 4.1.5, but this should be updated again to 4.1.latest (currently 4.1.14), either pinned specifically or ~> 4.1.5.

There are changes to how test DB schemas are maintained between 4.1.5 and 4.1.14 (db:test:prepare is no longer deprecated), so
this will need revising.

1.11.0 blocker, as 4.1.5 contains known security vulnerabilities.

Related issues:

Related to Foreman - Refactor #13409: Remove maintain_test_schemal! Rails init... Closed 01/27/2016
Related to Foreman Remote Execution - Bug #13666: Partials in app/overrides m... Closed 02/11/2016
Related to Foreman - Bug #13710: apipie:cache fails with Missing template ../... Closed 02/15/2016
Related to Foreman - Bug #13804: apipie:cache fails with :"en-GB" is not a va... Closed 02/19/2016
Related to Foreman - Bug #13977: Upgrade rails to 4.1.14.2 Closed 03/01/2016
Blocked by Foreman - Feature #7230: Upgrade Ruby on Rails to 4.1 Closed 08/22/2014
Blocked by Katello - Bug #13242: db:migrate fails under Rails 4.1.latest with... Closed 01/15/2016
Blocks Foreman - Feature #13244: Upgrade Ruby on Rails to 4.2 Closed 01/15/2016
Blocked by foreman-tasks - Bug #13335: Tests fail on Rails 4.1.14 Closed 01/22/2016
Blocked by Katello - Bug #13592: Partial ../overrides/foreman/activation_keys... Closed 02/08/2016

Associated revisions

Revision fd12fc8f - 02/15/2016 05:34 AM - Dominic Cleal
fixes #12873 - update Rails to 4.1.14.1

maintain_test_schema! changed behaviour and now launches db:test:prepare
in the background, causing the environment to be loaded again. A check
in the initializer prevents this from happening recursively.

Ideally this call would be removed from the initializers and leave it to
rails/test_help, but requires one of three solutions:

1. validates_lengths_from_database and validate_inclusion_in_families
must be lazier, not checking the database during class

initialisation. The Rails environment and even some models could be
loaded but only start working after the DB is available, instead of

not setting up their validators.

2. Remove all model class loading from the environment setup. The
apipie initializer can be made lazier, the HostObserver can be
refactored, but many plugins still cause models to be loaded through
to_prepare hooks.

3. Ignore the problem, always set up the test DB schema externally

before using rake tasks, without relying on rails/test_help and
maintain_test_schema.
Any of these would allow for the Rails environment to be loaded either
before the test DB schema is maintained without an effect on behaviour.

Test failures in the pagelets tests are fixed, which previously
referenced partials stored outside of the known view paths. These are
blocked by Rails in the Action View CVE-2016-0752 fix, so instead the
static fixtures directory is added to the view search paths.

History

#1 - 12/18/2015 06:07 AM - Dominic Cleal
- Blocked by Feature #7230: Upgrade Ruby on Rails to 4.1 added

#2 - 01/15/2016 08:50 AM - Dominic Cleal
- Status changed from New to Assigned

- Assignee set to Dominic Cleal

#3 - 01/15/2016 09:01 AM - Dominic Cleal

- Blocked by Bug #13242: db:migrate fails under Rails 4.1.latest with "katello_key system_groups_pkey" not found added

#4 - 01/15/2016 09:04 AM - The Foreman Bot
- Status changed from Assigned to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/3082 added

#5 - 01/15/2016 09:50 AM - Dominic Cleal
- Blocks Feature #13244: Upgrade Ruby on Rails to 4.2 added

#6 - 01/22/2016 12:40 PM - Eric Helms
- Blocked by Bug #13335: Tests fail on Rails 4.1.14 added

#7 - 01/27/2016 09:49 AM - Dominic Cleal

- Related to Refactor #13409: Remove maintain_test_schemal! Rails initializer added

#8 - 02/08/2016 04:27 AM - Dominic Cleal

- Blocked by Bug #13592: Partial ../overrides/foreman/activation_keys/_host _tab accessed outside of view paths added

#9 - 02/11/2016 09:53 AM - Dominic Cleal
- Related to Bug #13666: Partials in app/overrides must be moved into a views path added

#10 - 02/15/2016 06:01 AM - Dominic Cleal
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset fd12fc8f4b1{5d6e4fe9aeca97c21a8e1f23dc91.

#11 - 02/15/2016 07:19 AM - Dominic Cleal
- Related to Bug #13710: apipie:cache fails with Missing template ../../layouts/apipie/apipie added

#12 - 02/19/2016 06:52 AM - Dominic Cleal
- Related to Bug #13804: apipie:cache fails with :"en-GB" is not a valid locale added

#13 - 04/10/2016 03:06 AM - Tomer Brisker
- Related to Bug #13977: Upgrade rails to 4.1.14.2 added

#14 - 04/10/2016 03:07 AM - Tomer Brisker
- Bugzilla link set to 1325632
